function gmm_objempdistr(gaussobjpath,savepath)
% Combining single object property for statistical analysis including
% object size, number, and intensities

%protype = {'LAM','Nuc','Mit','TfR'};
files = ml_dir([gaussobjpath filesep '*gaussobjs.mat']);

%for each pattern in the protype list
for pidx = 1:1:length(files)
  if ~exist([savepath filesep files{pidx}], 'file' )

    %load the matfile that contains the gaussian objects
    load([gaussobjpath filesep files{pidx}]);

    % Intensity fit and number fit
    intensities = [];
    objsize = [];

    for i = 1:length(mixes)
        objnum(i) = 0;
        for j = 1:length(mixes{i})
            %if ~isempty(mixes{i}(j))
               %if ~isempty(mixes{i}(j).ncentres)
                for k = 1:mixes{i}(j).ncentres
                    %disp( [ '(i,j,k)=(' num2str(i) ',' num2str(j) ',' num2str(k) ')']);
                    intensities = [intensities;...
                        objintens{i}(j)*mixes{i}(j).priors(k)];
                    sigma = mixes{i}(j).covars(:,:,k);
                    sigma(:,end) = sigma(:,end) * 5;
                    sigma(end,:) = sigma(end,:) * 5;
                    lambda = sqrt(eig(sigma));
                    objsize = [objsize;fliplr(lambda')];
                   %catch
                    %disp( ['Ignoring object ' num2str(k) '.' ] );
                   %end
                end
               %end
               %end                
                try
                 objnum(i) = objnum(i) + mixes{i}(j).ncentres;
                catch
                 
                end
            end
        end    
    
     if ~exist( savepath, 'dir' )
       mkdir( savepath );
     end
      save([savepath filesep files{pidx}],'objsize','intensities','objnum')
 else  
disp( 'Intermediate results found, skipping recalculation' );
 end
end
